#include <gdal.h>

int main(int argc, char* argv[])
{
    GDALAllRegister();

    int arg = 1;
    if (argc >= 2)
    {
        arg = atoi(argv[1]);
    }

    GDALDatasetH hSrcDS = GDALCreate(GDALGetDriverByName("GTiff"), "src.tif",
                                     1000, 1000, 3, GDT_Byte, NULL); 
    GDALClose(hSrcDS);
    hSrcDS = GDALOpen("src.tif", GA_ReadOnly);

    char* options[] = {  "TILED=YES", "COMPRESS=JPEG", "PHOTOMETRIC=YCBCR", NULL };
    if (arg == 2)
        options[2] = NULL;

    GDALDatasetH hDstDS = GDALCreate(GDALGetDriverByName("GTiff"), "dst.tif",
                                     GDALGetRasterXSize(hSrcDS), GDALGetRasterYSize(hSrcDS), GDALGetRasterCount(hSrcDS), GDT_Byte, options); 
    
    if (arg == 3)
    {
        GDALClose(hDstDS);
        hDstDS = GDALOpen("dst.tif", GA_Update);
    }

    GDALDatasetCopyWholeRaster(hSrcDS, hDstDS, NULL, NULL, NULL);

    GDALClose(hDstDS);

    return 0;
}
